function x = basstr2basvec(str,basis)
%  x = basstr2basvec(str,basis)
%  wandelt den String mit der Stellendarstellung bezglich 
%  der Basis basis um in den Vektor der Stellendarstellung.
%  str beginnt mit der hchstwertigen Stelle, x mit der niederwertigsten.

%  Autor:  Klaus von der Heide,  v.d.heide@on-line.de

ip = findstr(str,'.');
if length(ip)>1  error('basstr2basvec: mehr als ein Punkt im String'); end
if length(ip)==1
   str = str([1:ip-1  ip+1:end]);
end
charzif = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
if (basis<2)|(basis>length(charzif)) error('basstr2num: Basis nicht aus 2:64'); end
if checkchar(str,charzif)  error('basstr2num: falsche Ziffer'); end

for k=1:length(str)
   zif(k) = findstr(str(k),charzif) - 1;
end

x = reverse(zif);