function x = basstr2num(str,basis)
%  x = basstr2num(str,basis)
%  wandelt den String mit der Stellendarstellung bezglich 
%  der Basis basis um in die natrliche Zahl x.

%  Autor:  Klaus von der Heide,  v.d.heide@on-line.de

ip = findstr(str,'.');
if length(ip)>1  error('basstr2num: mehr als ein Punkt im String'); end
if length(ip)==1
   str = str([1:ip-1  ip+1:end]);
end
charzif = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
if (basis<2)|(basis>length(charzif)) error('basstr2num: Basis nicht aus 2:64'); end
if checkchar(str,charzif)  error('basstr2num: falsche Ziffer'); end

for k=1:length(str)
   zif(k) = findstr(str(k),charzif) - 1;
end

x = sum(reverse(zif).*basis.^(0:length(str)-1));

if length(ip)==1
   x = x*basis^-(length(str)-ip+1)
end
