function z = basvec2num(v,basis,f)
%  z = basvec2num(v,basis,f)
%  interpretiert den Vektor v als Stellendarstellung zur
%  Basis basis und berechnet die entsprechende natrliche Zahl z.
%  Falls f=1 angegeben wird, erfolgt keine Argumentprfung.

%  Autor:  Klaus von der Heide,  v.d.heide@on-line.de

if nargin<3 | (nargin>2 & f~=1)
   if any(or(v<0,v>basis-1)) 
      error('basvec2num: Element von v negativ oder grsser als Basis-1');
   end
   vv = floor(v);
   if any(vv~=v)  error('basvec2num: v ist nicht array of integer'); end
end

z = v(end:-1:1)*cumprod([1 basis*ones(1,length(v)-1)])';