function s = basvec2str(bv,n)
% s = basvec2str(bv)
% Wandlung des Vektors einer Stellendarstellung in einen String.
% bv :  Vektor der Stellen (natrliche Zahlen < Basis
%       beginnent mit der niederwertigsten Stelle
% n  :  wenn die Stellenzahl n angegeben ist, werden fhrende 
%       Nullen ausgegeben bzw. die hchstwertigen Stellen
%       abgeschnitten
% s  :  String der Stellendarstellung beginnend mit der 
%       hchstwertigen Stelle

%  Autor:  Klaus von der Heide,  v.d.heide@on-line.de

if nargin<2  n = length(bv); end

charzif = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';

rbv = reverse(bv+1);
rbv = [ones(1,n-length(rbv)) rbv];
s = charzif(rbv(length(rbv)-n+1:end));
