function x = bcomplstr2num(str,basis,mxplus)
%  x = bcomplstr2num(str,basis,mxplus)
%  wandelt den String mit der Stellendarstellung bezglich 
%  der Basis basis um in die ganze Zahl x.
%  Ist die Interpretation als natrliche Zahl grsser als
%  mxplus, so wird das Basis-Komplement angenommen.

%  Autor:  Klaus von der Heide,  v.d.heide@on-line.de

if nargin<2  basis = 2; end
if nargin<3  mxplus = floor((basis^length(str) - 1)/2); end

charzif = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
if (basis<2)|(basis>length(charzif)) error('basstr2num: Basis nicht aus 2:64'); end
if checkchar(str,charzif)  error('basstr2num: falsche Ziffer'); end

for k=1:length(str)
   zif(k) = findstr(str(k),charzif) - 1;
end

x = sum(reverse(zif).*basis.^(0:length(str)-1));

if x>mxplus
   x = x - basis^length(str);
end
