function outsym = bitstuffing(rx,n,insym,symbole)
% outsym = bitstuffing(rx,n,insym,symbole)
% rx = 0  :  Einfgung des Symbols symbole(2) nach n gleichen 
%            Symbolen symbole(1) und umgekehrt. 
%            Als symbol(2) werden alle Symbole ~= symbol(1) angesehen.
% rx = 1  :  nach n gleichen Symbolen z wird ein Symbol gestrichen
% n       :  siehe rx
% insym   :  die Eigabesequenz
% symbole :  die benutzten Binrsymbole (Default: [0,1])
% outsym  :  die Ausgabesequenz
%
% bitstuffing dient bei Strings zur "Finnisierung" (und umgekehrt): 
% bitstuffing(0,3,'   dies ist kein Text!!',' ')

% Autor: Klaus von der Heide; e-mail: v.d.heide@on-line.de

if nargin<4  symbole = [0,1]; end
if nargin<3  insym   = randb(64); end
if nargin<2  n = 5; end
if nargin<1  rx = 0; end
nullen = 0;
einsen = 0;
weglas = 0;

x = [];
for k=1:length(insym)
   if rx==0                    % Sender
      if nullen==n  
         x = [x,symbole(2)];
         nullen = 0;
      elseif einsen==n  
         x = [x,symbole(1)];
         einsen = 0;
      end
      x = [x,insym(k)];
   else                        % Empfnger
      if nullen==n
         nullen = 0;
         weglas = 1;
      elseif einsen==n
         einsen = 0;
         weglas = 1;
      else  
         x = [x,insym(k)];
         weglas = 0;
      end
   end
   if ~weglas
      if insym(k)==symbole(1) 
         nullen = nullen + 1; 
         einsen = 0;
      else
         nullen = 0;
         einsen = einsen + 1;
      end
   end
end

if rx==0                    % Sender
   if nullen==n  
      x = [x,symbole(2)];
   elseif einsen==n  
      x = [x,symbole(1)];
   end
else                        % Empfnger
   if nullen==n | einsen==n
      x = x(1:end-1);
   end
end

outsym = x;         