% Kurs Digitale Datenbertragung
% ==============================
% Universitt Hamburg, Fachbereich Informatik
% Autor: Klaus von der Heide, e-mail:  v.d.heide@on-line.de
% Folgende Funktionen wurden von anderen Autoren bernommen:
% wavreadx.
%
% Mit der Student Edition kann man sich den Kommentar zu den einzelnen 
% Funktionen nicht durch Doppelklick anzeigen lassen. Tippen Sie help ...
%
%
% Audio
%   wavreadx       - Lesen von 8- und 16-Bit-WAV-Dateien
%
% Kodes (siehe auch Statistik)
%   crc            - CRC-Berechnung
%   dediffencode   - Dekodierung der differentiellen Binrkodierung
%   demanchester   - Dekodierung eines Manchester-kodierten Binrvektors
%   diffencode     - differentielle Binrkodierung
%   entfaltdemo    - Dekodierung durch vollstndige Suche nach grsster Korrelation
%   faltcode       - Kodierung mit Faltungskode
%   faltcodesim    - Simulation der Faltungskodierung und Dekodierung
%   faltpoly       - Polynome fr Faltungskodes
%   hamming7_4     - Matrix der Kodewrter des (7,4)-Hammingkodes
%   hamminggenerator - Generator- und Prfmatrix fr binre Hammingkodes
%   rekfalt2       - PCR-Kodierer
%   simhardsoft    - Bitfehlerstatistik bei AWGN und zyklischen Kodes
%   simsoftdecode  - Soft- und Hard-Decision fr (7,4)-Hammingkode
%   softdecode     - Dekodierung durch Korrelation 
%   viterbi        - Viterbi-Algorithmus zur Soft-Dekodierung
%   viterbitest    - Demo fr Viterbi-Dekoder
%
% Direkte Digitale Synthese und Phase Locked Loop
%   ddsgraph       - Graphik zur Erluterung der DDS
%   ddssim         - Simulation der DDS
%   sfdrgraph      - Spurious Free Dynamic Range fr DDS-Methoden
%   sinprec        - Geauigkeit der Sinusberechnung
%
% Filter
%   cosrolloff     - Berechnung der Kosinus-Rolloff-Funktion
%   crfir          - Entwurf von Cosinus-Rolloff-Filtern
%   filterplot     - universelle Darstellung von Filtergngen
%   wcrfir         - Entwurf von Wurzel-Cosinus-Rolloff-Filtern
%
% Graphiken
%   faltstruktur   - Prinzip der Faltungskodierung
%   trellisdiag    - Trellisdiagramm
%   trelliswege    - Vereinigung von Wegen 
%   trellisviterbi - Erluterung zum Viterbi-Algorithmus
%
% Informationsreprsentation
%   binmat2num     - Interpretation der Zeilenbitvektoren als natrliche Zahlen
%   basvec2num     - Radixdarstellung bzgl. Basis nach Zahl
%   binvec2num     - Wandlung eines Bitvektors in natrliche Zahl
%   binvec2str     - Wandlung eines Bitvektors in einen ASCII-String
%   bitstuffing    - Bitstuffing und umgekehrt
%   charziffer     - nat. Zahl 0...15 nach Char '0' ... 'F'
%   int2gf         - Wandlung Zahl nach Stellensystem bzgl. Basis gf
%   limprec        - Begrenzung auf n Binrstellen
%   num2basstr     - String der Radixdarstellung bzgl. Basis
%   num2basvec     - Vektor der Ziffern der Radixdarstellung bzgl. Basis 
%   num2binvec     - Wandlung Zahl nach Bitvektor
%   str2binvec     - Wandlung String nach Bitvektor
%
% Mathematik
%   binko          - Binomialkoeffizient
%   fourierplot    - Darstellung von Funktionen und deren Fouriertransformierten
%   fourectdemo    - Fouriersynthese einer Rechteckschwingung
%   ifourierplot   - Darstellung von komplexen Funktionen und Transformierten
%   nyquistinterpol - Shannoninterpolation
%
% Modulation und Demodulation
%   amplmod        - Amplitudenmodulation und Demodulation
%   dsbmod         - Zweiseitenbandmodulation (ohne Trger)
%   freqmod        - Frequenzmodulation und Demodulation
%   modspec        - Demonstration der Modulationsarten: Spektren
%   pcmod          - Pulscodemodulation
%   pdmod          - Pulsdauermodulation
%   pddemod        - Demodulation der Pulsdauermodulation
%   phasenmod      - Phasenmodulation und Demodulation
%   qamgraph       - graphische Erluterung der QAM
%   qammod         - Quadraturmodulation und Demodulation
%   ssbmod         - Einseitenbandmodulation
%
% Kanaleigenschaften (siehe auch unter Rauschen)
%   fadingsim      - Fadingdiagramm
%   kanalgraph     - Graphik fr das Schema eines gestrten Kanals
%   kanalkap       - Kanalkapazitt
%   kanalkapdb     - Kanalkapazitt fr in dB gegebenes SNR
%   mehrweg        - Fading-Demo zur Mehrwegeausbreitung
%   nichtlinear    - Ausgabesprektrum eines nichtkinearen Systems
%   zweiweg        - Graphik zur Zweiwegeausbreitung
%
% Nachrichtentechnik
%   augendiagramm  - Augendiagramm
%   costasgraph    - Graph der Struktur eines Costas Loop
%   fernsprechkanal - Modell eines Fernsprechkanals
%   fskrx          - FSK-Empfnger mit Start/Stopp-Synchronisation
%   fsktx          - FSK-Sender mit Start/Stopp-Synchronisation
%   fsktest        - komplette Datenbertragung mit FSK und Start/Stopp
%   fsktx          - FSK-Sender mit Start/Stopp
%   mpsk_noise     - Signalraumdarstellung von mPSK mit Rauschen
%   mpsk_noise2    - Signalraumdarstellung von mPSK mit Rauschen
%   nqispectrum    - Spektrum von Shannoninterpolation
%   p3drx          - Empfnger fr den P3d-Satelliten AO-40
%   p3drx2         - Empfnger fr den P3d-Satelliten AO-40
%   p3dtx          - Simulation des Telemetrie-Senders fr AO-40
%   pactor2rx      - Empfnger fr das Pactor2-Verfahren
%   pactor2tx      - Sender fr das Pactor2-Verfahren
%   qam14k4        - 64-Punkte-QAM: Signalraumdiagramm
%   raisedcosine   - Verbindung diskreter Werte durch raised Cosine
%   rcsinc         - sinc-Funktion mit Hanning-Fenster
%   rcspectrum     - Darstellung des Spektrums fr Raised Cosine
%   schrittsync    - Demo fr Schrittsynchronisation durch kleinste Quadrate
%   startstop      - Demo fr Start/Stopp-Synchronisation
%   txrxfilter     - Demo: Filter, Sendepuls, Augendiagramm, etc.
%   v21_startstop  - FSK-Modem nach V.21
%   v22bis         - Signalraumdarstellung fr V.22bis
%   v27bis         - Signalraumdarstellung fr V.27bis
%   v29            - Signalraumdarstellung fr V.29
%
% Skript des Kurses:
% Die Kapitel und Abschnitte werden Baum-artig durch Anklicken
% aufgerufen. Sie sind hier nicht aufgefhrt. Siehe README.TXT
%
% Zufallszahlen und Rauschen
%   add_awgn       - Addition von weissem Gauss-Rauschen
%   awgn_vert      - Histogramm fr Binrsignal mit Gauss-Rauschen
%   ebn2sigma      - Standardabweichung fr AWGN bei gegebenem Eb/No
%   mPSK-err       - Plot der Bitfehlerwahrscheinlichkeit bei 4..64PSK
%   perr_psk       - Plot der Bitfehlerwahrscheinlichkeit bei PSK
%   randb          - Binres Zufallsmuster
%   randpermut     - Generierung einer zuflligen Permutation der Zahlen 1...n
%   randx          - Zufallsmuster aus vorgegebener Menge
%
% Signaldarstellung und Zeit-Diskretisierung, Animationen
%   abtastbild     - Darstellung der Abtastung
%   analytsig      - Animierte Signalraumdarstellung
%   abtastanimation - Darstellung eines komplexen Vektors
%   binmatout      - komprimierte Ausgabe von Binrmatrizen ohne Blanks
%   complex_noise  - Signalraumdarstellung 
%   fktabtast      - Abtastung einer Funktion mit Quantisierung
%   impulsfolge    - Sendesignal = Faltung Symbolvektor*Impulsform
%   komplexanimat  - Animierte Signalraumdarstellung
%   zeitspecgraph  - Darstellung eines Impulses ber der Zeit-Frequenz-Ebene
%
% Distributionen
%   Dirac          - Dirac'sche Deltafunktion
%   diracpuls      - Approximation des Diracpulses durch eine Gauss-Funktion
%   Heaviside      - Heaviside'sche Sprungfunktion
%
% Statistik
%   binomialplot   - Darstellung der Binomialverteilung
%   binomialsum    - Summe ber die Binomialverteilung von k bis n
%   binomialvert   - Binomialverteilung
%   fehl_vert      - Darstellung von Bitfehlerwahrscheinlichkeiten
%   p_dec_ok       - Wahrscheinlichkeit korrekter Dekodierung fr (n,k)-Code
%   plot_code_gain - Bitfehlerwahrscheinlichkeit fr (n,k)-Code (Plot)
%   simsoftdecode  - Simulation von harter und weicher Entscheidung
%
% Hilfsfunktionen
%   addtrellisdiag - Hinzufgen von Wegen in trellisdiag
%   ar2db          - Amplitudenverhltnis nach dB
%   db2ar          - dB nach Amplitudenverhltnis
%   db2pr          - dB nach Leistungsverhltnis
%   delay          - Indexverschiebung bei Vektoren
%   diracpuls      - Approximation des Diracpulses zum Plotten
%   drawarr        - Pfeil zeichnen
%   drawccir       - Kreis zeichnen um Mittelpunkz
%   drawcsq        - Rechteck zeichnen um Mittelpunk
%   drawsq         - Rechteck zeichnen an Ecke
%   flach          - Wandlung Matrix und bel. Struktur nach Vektor
%   fmaxkomp       - Bestimmung der Frequenz maximaler Amplitude in Signalen
%   fullscreen     - Erzeugung und Konfektionierung eines Vollformat-Bildes
%   inputbinmat    - Eingabe einer Binrmatrix ber die Tastatur
%   nfach          - Ver-n-fachung jeder Komponente eines Vektors
%   nullein        - Einfgung von Nullen zwischen Vektorkomponenten
%   pll            - Phase Locked Loop (Demo)
%   pllgraph2      - Graphik zum Schema einer PLL
%   pllgraph3      - Graphik zum Schema einer PLL mit quadrierendem Regelkreis
%   pr2db          - Leistungsverhltnis nach dB
%   real2analyt    - Wandlung eines reellen in ein analytisches Signal
%   reverse        - Spiegelung von Vektoren
%   rotatevector   - Rotation der Komponenten eines Vektors um d Stellen
%   screen         - Hilfsfunktion fr Bildschirmeinstellung
%   specrot        - Spektrale Rotation eines Filterfrequenzganges
%   swap           - Vertauschung von Vektorkomponenten
%   suchmuster     - Suche eines binren Musters in einem Binrvektor
%   zyktoeplitz    - zyklische Toeplitz-Matrix
%
% KeyPressFcn (Hilfsfunktionen zur Interaktion)
%   anicont        - Geschwindigkeitssteuerung einer Animation
%   hervorhebung   - Hervorheben bestimmter Linienobjekte
%   sichtbarkeit   - Ein- und Ausschalten von Linienobjekten
%   togglevisibility - Ein- und Ausschalten von Linienobjekten
%   xzoom          - Zoom und Scroll in x-Richtung
%   xzoomvis       - Zoom und Scroll in x-Richtung sowie Ein/Ausschalten von Linien
%   zoom3d         - Zoom und Scroll in drei Richtungen
%
% Nicht als MATLAB-Skript oder -Funktion vorliegende Dateien
% (keine weitere Erluterung vorhanden)
%   DDS-Struktur.GIF - Graph zur DDS-Struktur
%   KVV.TXT          - KVV-Text zur Vorlesung
%   MSCRIPTVIEW.TXT  - Hilfetext zu mscriptview
%   README.TXT       - Basis-Erluterung zur Toolbox
%   sprache.mat      - load('sprache') liefert auf x abgetastete Spache (fs = 8000 Hz)
%   lrkanal.mat      - load('lrkanal') liefert Samples fr 'linker', 'rechter','Kanal'
%   P3dsk.wav        - Signal des P3d-Satelliten AO-40
