function h = drawarr2(von,nach,farbe,lw,spl,re,rs)
%  h = drawarr(von,nach,farbe,lw,spl,re,rs)
%  Zeichnet einen Pfeil der farbe und Strke lw sowie
%  der Spitzenlnge spl zwischen den Koordinaten von und nach.
%  Die Lnge des Pfeils lsst sich am Schaft bzw. an der Spitze
%  um re bzw. rs krzen. nach kann deshalb der Mittelpukt eines
%  Kreises sein und rs dessen Radius. 
%  Die Spitzenlnge bezieht sich auf die Lnge des Einheitsvektors
%  in x-Richtung bei den gegebenen Achsen.
%  Zurckgegeben werden die Handles der Linie und Spitze.
%  Die Achsen sollten vor dem Aufruf von drawarr festgelegt werden.

% K. v. d. Heide,  e-mail:  v.d.heide@on-line.de

% Defaults
% ========
if nargin<7  rs  = 0; end
if nargin<6  re  = 0; end
if nargin<5  spl = 3; end
if nargin<4  lw  = 2; end
if nargin<3  farbe = 'k'; end

% Konstanten
% ==========
pos  = get(gcf,'Position');
xl   = get(gca,'XLim');
yl   = get(gca,'YLim');
xs   = (xl(2)-xl(1))/pos(3);
ys   = (yl(2)-yl(1))/pos(4);
q    = xs/ys;
u    = nach - von;
lu   = norm(u);
u    = u/lu;  
%ux   = u(1);
%uy   = u(2);
shft = von  + re*u;
spze = nach - rs*u;
a    = spl*(-1+i/7)*(u(1)+i*u(2));
b    = spl*(-1-i/7)*(u(1)+i*u(2));
aa   = spze + [real(a)  imag(a)];
bb   = spze + [real(b)  imag(b)];

% Pfeil
% =====
h  = [line([shft(1),spze(1)],[shft(2),spze(2)],'Color',farbe,'LineWidth',lw),...
      patch([spze(1) aa(1) bb(1)],[spze(2) aa(2) bb(2)],farbe)];

