function lh = drawcircle(x,y,r,varargin)
% lh = drawcircle(x,y,r,varargin)
% zeichnet einen Kreis mit Mittelpunkt [x,y]
% und Radius r.  Der Kreis ist optisch ein Kreis 
% auch bei unterschiedlicher Skalierung in x und y.
% lh ist das line handle.
% Alle line properties knnen nach den ersten 
% drei Parametern gesetzt werden.

% K. v. d. Heide,  e-mail:  v.d.heide@on-line.de

% Skalenverhltnis x/y
% ====================
fp = get(gcf,'Position');
ap = get(gca,'Position');
ax = axis;
sv = 0.95*fp(3)/fp(4)*ap(4)/ap(3)/((ax(2)-ax(1))/(ax(4)-ax(3)));

% Kreis
% =====
n  = 32;
k  = (0:n)/n*2*pi;
xx = x + r*cos(k)/sv;  
yy = y + r*sin(k);
lh = line(xx,yy,varargin{:});
