function [ph,th] = drawcsq(mitte,kante,farbe,wort,pt)
%  [ph,th] = drawcsq(mitte,kante,farbe,wort,pt)
%  Zeichnet ein mit farbe geflltes Quadrat
%  der Kantenlnge kante an die Position mitte.
%  In das Quadrat wird der Text wort geschrieben 
%  mit der Fontgrsse pt.
%  Ausgegeben werden Patch-Handle und Text-Handle.

% K. v. d. Heide,  e-mail:  v.d.heide@on-line.de
%
if nargin<3 farbe = 'w'; end
if nargin<2 kante = 10; end
if nargin<1 mitte = [0 0]; end
x0 = mitte(1) - kante/2;  y0 = mitte(2) - kante/2;
ph = patch([x0,x0+kante,x0+kante,x0],[y0,y0,y0+kante,y0+kante],farbe);
if nargin>3
   if nargin<5 pt    = [12]; end
   th = text(mitte(1),mitte(2),wort);
   set(th,'HorizontalAlignment','center','FontSize',pt)
end