function y = findcell(x,c,inx)
% y = findcell(x,c)
% Suche nach Elementen im CellArray c mit c{i}{j}... = x.
% Ausgegeben wird ein CellArray y mit den Vektoren [i, j, ...] 
% jeweils aller Indices.
% x kann ein CellArray oder ein String oder ein numerisches Feld 
% beliebiger Dimension sein.
% Beispiele:  findcell(0,{1,0,{3,{0,{{0,5,0},1}}}}) liefert
%                     {[2] [3 2 1] [3 2 2 1 1] [3 2 2 1 3]}
% findcell({{0,5,[0,1]},'Hallo'},{[1,0],{3,{0,{{0,5,[0,1]},'Hallo'}}}}) 
% liefert  {[2 2 2]}

% Autor:  Klaus von der Heide,  v.d.heide@on-line.de

if nargin<3  inx = []; end
kx = length(inx) + 1;
y  = {};
for k=1:length(c)
   inx(kx) = k;
   if iscell(c)
      if cmptree(x,c{k})  
         y = cat(2,y,{inx}); 
      else
         y = cat(2,y,findcell(x,c{k},inx));
      end
   elseif cmptree(x,c)
      y = cat(2,y,{inx});
   end
end
