function hervorhebung
% Steuerung der Strichstrke durch Eingabe ber die Tastatur:
% Durch Drcken der Zifferntaste  z (z = 1...9) kann im 
% obenliegenden Fenster das Linienobjekt z verndert werden. 
% Die Strichstrke toggelt zwischen normal und dick (3.0).
% Mit den Tasten x bzw. y toggelt man zwischen linearer und 
% logarithmischer Skala in x- bzw. y-Richtung.

% Autor: K. von der Heide, e-mail:  v.d.heide@on-line.de

lo = findobj(gcf,'type','line');      % alle line-Objekte
k  = double(get(gcf,'CurrentCharacter')) - 48; % Objektnummer
if (k>0)&(k<=length(lo))              % sonst falsche Eingabe
   al = lo(length(lo) - k + 1);       % Index in der Liste
   ud = get(gcf,'UserData');          % UserData des Bildes
   switch ud{1}(k)
      case 0,  set(al,'LineWidth',3);
      case 1,  set(al,'LineWidth',ud{2}(k));
   end 
   ud{1}(k) = rem(ud{1}(k)+1,2);
   set(gcf,'UserData',ud)             % Update UserData
end
if k==72                              % Taste "x"
   switch get(gca,'XScale')
      case 'linear', set(gca,'XScale','log')
      case 'log',    set(gca,'XScale','linear')
   end
end
if k==73                              % Taste "y"
   switch get(gca,'YScale')
      case 'linear', set(gca,'YScale','log')
      case 'log',    set(gca,'YScale','linear')
   end
end
if (k==56)|(k==24)                    % Taste "H" bzw. "h"
   fs = 12;
   helpwin = figure;
   set(helpwin,'NumberTitle','off','Name','HelpWin',...
      'Color','w','MenuBar','none','Position',[4 470 400 222],...
      'KeyPressFcn','delete(gcf)','ButtonDownFcn','delete(gcf)')
   axis([0,80,1,10]); axis off
   text(0,9,'Das obenliegende Bild kann durch','FontSize',fs)
   text(0,8,'Tastatureingabe verndert werden:','FontSize',fs)
   text(0,7,'Taste   Wirkung','FontSize',fs)
   text(0,6,'  1     Toggeln der Strichstrke der Line-Objekte 1','FontSize',fs)
   text(0,5,'  2     Toggeln der Strichstrke der Line-Objekte 2','FontSize',fs)
   text(0,4,' usw. bis maximal 9','FontSize',fs)
   text(0,3,'  x     Toggeln zwischen lin- und log-Skala in x','FontSize',fs)
   text(0,2,'  y     Toggeln zwischen lin- und log-Skala in y','FontSize',fs)
   text(0,1,'  h     dieses Hilfe-Fenster erzeugen','FontSize',fs)
end
if k==-21  msvdelfig;   end
if k==79   delete(gcf); end
