function x0 = int2gf(z,n,b)
% gfvec = int2gf(z,n,b)
% wandelt die natrliche Zahl z in einen Zeilenvektor 
% von n Symbolen fr die Stellendarstellung zur Basis b.
% Ist z ein Spaltenvektor, so wird eine Matrix ausgegeben,
% deren Zeilen die Stellendarstellung der Komponenten von z ist.
% num2basvec(z,basis,n) tut das selbe, jedoch nicht fr Spaltenvektoren z.

if any(z>b^n-1)  error('int2gf :  Argument zu gross fr n Stellen'); end
if any(z<0)      error('int2gf :  Argument negativ'); end
zz = z;
mm = []; 
for k = n:-1:1
   m  = fix(zz/(b^(k-1)));
   zz = zz - m*b^(k-1);
   mm =[mm m];
end
x0 = mm;
 



