function z = mssearch(s,datei,rek)
% z = mssearch(s,datei,rek)
% Die ASCII-Datei datei wird durchsucht nach dem String s. 
% Ausgegeben wird ein Vektor, der die Nummern der Zeilen enthlt, 
% in denen der String gefunden wurde.
% Falls ein Link auf eine Datei fhrt, die den String enthlt, 
% so wird die Zeile des Links angegeben.
% Falls der String nicht gefunden wird, ist  z = [].
% Links werden nur bis zur Rekursionstiefe 5 verfolgt.

% Autor: Klaus von der Heide, e-mail:  v.d.heide@on-line.de

if ~ischar(datei) | length(datei)<2  z = []; break; end
if     ~ischar(s) | length(s)<2      z = []; break; end
if rek>4                             z = []; break; end

% Datei ffnen
% ============
file = reverse(deblank(reverse(datei)));   % Spaces am Ende wegnehmen
if ~ismember('.',file)  file = strcat(file,'.m'); end
fid    = fopen(file,'rt');
if fid<0                             z = []; break; end  % Datei existiert nicht 
frewind(fid);   % ffnen der Textdatei

% Suchen
% ======
z = [];
zeinr = 1;                      % Zeilenzeiger auf 1 setzen
while ~feof(fid)
   zeile = fgets(fid);
%   if iscomment(zeile)==1
   if ismember(iscomment(zeile),[1 3])
      ix    = findstr(upper(s),upper(zeile));
      if ~isempty(ix) 
         z = [z,zeinr];
      end
   elseif length(zeile>5)
      k = findstr(zeile,'%MSV');
      if length(k)>0
         k = k(1);
         zz = mssearch(s,zeile(1:k-1),rek+1);
         if ~isempty(zz)
            z = [z,zeinr];
            break               % zur Beschleunigung abgebrochen  
         end
      end
   end
   zeinr = zeinr + 1;
end
