% Skript als KeyPressFunction fr Textfenster mit m-Files.
%
% Bedienung:
% Vorwrts- und Rckwrtsgehen im Text:
% Abschnitts-weise mit den Tasten + bzw. -
% Seiten-weise mit der Taste n (next) bzw. l (last)
%
% Ausfhren des durch Balken und Fettdruck markierten MATLAB-Blocks 
% mit der Taste r (falls dies eine Zeile ist, die den String "%MSV"
% enthlt, wird das Skript mit mscriptview aufgerufen
%
% Ausfhren des durch Balken und Fettdruck markierten Skripts
% in einem neuen mscriptview-Fenster mit der Taste v
%
% Kopieren des durch Balken und Fettdruck markierten MATLAB-Blocks 
% in ein Editorfenster mit der Taste c
%
% Alle Variablennamen beginnen mit  kpf_

% Autor: Klaus von der Heide, e-mail:  v.d.heide@on-line.de

% Globale Konstanten
% ==================
global MSVTITLFONT MSVTITLWEIGHT MSVTITLSIZE MSVTITLCOLOR MSVTITLANGLE
global MSVTEXTFONT MSVTEXTWEIGHT MSVTEXTSIZE MSVTEXTCOLOR MSVTEXTANGLE
global MSVKOMTFONT MSVKOMTWEIGHT MSVKOMTSIZE MSVKOMTCOLOR MSVKOMTANGLE
global MSVCODEFONT MSVCODEWEIGHT MSVCODESIZE MSVCODECOLOR MSVCODEANGLE
global MSVFORMFONT MSVFORMWEIGHT MSVFORMSIZE MSVFORMCOLOR MSVFORMANGLE
global MSVMSVFONT MSVMSVWEIGHT MSVMSVSIZE MSVMSVCOLOR MSVMSVANGLE 
global MSVMARKCOLOR MSVSUCHCOLOR MSVSUCHTEXT MSVZEILEN MSVSPALTEN MSVBUSY

if isempty(MSVTITLFONT)  msvinit; end

kpf_pcolor = 'w';          % Color fr pause-Kommandos u..
kpf_tf = gcf;
kpf_ta = gca;
kpf_cc = get(kpf_tf,'CurrentCharacter');

if isempty(MSVSUCHTEXT) 
   kpf_such = 0; 
else 
   kpf_such = 1; 
   set(kpf_tf,'Pointer','watch')
end

switch kpf_cc

   case 'b', print -dbitmap
% Das obenliegende Fenster als Bitmap in den Zwischenspeicher kopieren
      
   case 'p', printdlg(gcf)
% !!! dies sollte wesentlich erweitert werden mit folgenden Optionen: !!!
% 1.  Druck des ausgewhlten Fensters (wie bisher)
% 2.  Druck der aktuellen Sriptdatei mit TEX-Interpretation ausser bei MATLAB
% 3.  wie 2. jedoch MATLAB-Blcke soweit mglich ersetzt oder ergnzt durch 
%     deren Ausgabe
% siehe  mscriptprint.m
   
   case 'e'
% Die markierte Textzeile editieren
% !!! nicht implementiert !!!      
   
   case 'x'
% Editormodus verlassen
% nicht implementiert

   case 'c'
% Den markierten MATLAB-Block ins Editorfenster kopieren      
      kpf_fid = get(kpf_tf,'UserData');
      kpf_zei = get(kpf_ta,'UserData');
      kpf_mzeile = kpf_zei{4};
      frewind(kpf_fid)
      for kpf_k=1:kpf_mzeile  kpf_zeile = fgetl(kpf_fid); end
      
      if kpf_mzeile>0
% MATLAB-Block kopieren
%         kpf_temp = [fileparts(fopen(kpf_fid)) 'mstemp.m'];
%         kpf_temp = fullfile(fileparts(fopen(kpf_fid)),'mstemp.m');
         kpf_temp = fullfile(fileparts(which('mscriptview.m')),'mstemp.m');
         kpf_tfid = fopen(kpf_temp,'wt');
         while ~feof(kpf_fid)&~iscomment(kpf_zeile)
            fprintf(kpf_tfid,'%s\n',kpf_zeile);
            kpf_zeile = fgetl(kpf_fid);
         end
         fclose(kpf_tfid)
         edit(kpf_temp)
      end

   case 'r'
% Den markierten MATLAB-Block ausfhren
      kpf_fid = get(kpf_tf,'UserData');
      kpf_zei = get(kpf_ta,'UserData');
      kpf_mzeile = kpf_zei{4};
      frewind(kpf_fid)
      for kpf_k=1:kpf_mzeile  kpf_zeile = fgetl(kpf_fid); end
      kpf_mstmpc = fullfile(fileparts(which(fopen(kpf_fid))),'msvtempcode.m');
      clear(kpf_mstmpc);
      kpf_ftmp = fopen(kpf_mstmpc,'wt');
      frewind(kpf_ftmp);
      if kpf_mzeile>0
% MATLAB-Block bertragen in Datei  msvtempcode.m
         while ~feof(kpf_fid)&~iscomment(kpf_zeile)
            kpf_i = findstr('%MSV',kpf_zeile);
            if isempty(kpf_i)
               if MSVBUSY==0     % Warte-Fenster zeigen
                  MSVBUSY = figure('Name','Warten','Color','w','MenuBar','none',...
                                    'NumberTitle','off','Position',[386 332 240 80]);
                  text(0.1,0.5,'Bitte warten','FontSize',20,'Color','r')
                  axis 'off'
                  set(bdf_tf,'Pointer','watch')
                  pause(0.001)
               end
               fprintf(kpf_ftmp,'%s\n',kpf_zeile);
            else
               mscriptview(kpf_zeile(1:kpf_i(1)-1))
               break
            end
            kpf_zeile = fgetl(kpf_fid);
         end
         fclose(kpf_ftmp);
% MATLAB-Block ausfhren
         try,  msvtempcode; end
         clear msvtempcode;                    % temporre Kopie aus workspace entfernen
      end
% Wartefenster lschen
      if MSVBUSY~=0  
         if ismember(MSVBUSY,findobj('Type','figure')) delete(MSVBUSY); end    % Warte-Fenster lschen 
         set(kpf_tf,'Pointer','arrow')
         MSVBUSY = 0;
      end

   case 'h'
% Hilfe-Fenster darstellen
      fontname = 'Courier';
      fontsize = 13;
      kpf_helpwin = fullscreen('HelpWin','w',0,[1.5 1.8; 1.25 1.0]);
      set(kpf_helpwin,'KeyPressFcn','delete(gcf)','ButtonDownFcn','delete(gcf)')
      axis([8,80,1.5,26]); axis off
      text(0,26.0,'Folgende Interaktion mit dem Text ist mglich:',...
               'FontName','times','FontSize',fontsize+2,'FontWeight','bold')
      text(0,23.5,'vorwrts  :  mit den Tasten "+" oder "n"(next)',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,22.5,'             sowie mit Mausklick unter dem Text',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,21.0,'rckwrts :  mit den Tasten "-" oder "l"(last)',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,20.0,'             sowie mit Mausklick ber dem Text',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,18.5,'markierten MATLAB-Block ausfhren:',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,17.5,'             mit der Taste "r"(run)',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,16.5,'             sowie mit Mausklick in den markierten Block',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,15.0,'MATLAB-Block markieren:',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,14.0,'             mit Mausklick in den Block',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,12.5,'MSV-Fenster lschen:',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,11.5,'             mit der Taste "ENTF" ("DEL")',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,9.5,'Alle Graphik-Fenster lschen:',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,8.5,'             mit der Taste "ESC"',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,7.0,'MSV-Fenster als Bitmap ins Clipboard kopieren:',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,6.0,'             mit der Taste "b"',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,4.5,'MSV-Fenster drucken:',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,3.5,'             mit der Taste "p"',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,2.0,'Suchen    :  mit der Taste "s"(search)',...
               'FontName',fontname,'FontSize',fontsize)
      text(0,1.0,'Suchen beenden :  Taste "s", ohne Eingabe "OK" klicken',...
               'FontName',fontname,'FontSize',fontsize)
      
   case 'n'
% Nchstes Textfenster darstellen
      delete(get(kpf_ta,'children'))
      kpf_fid = get(kpf_tf,'UserData');
      kpf_zei = get(kpf_ta,'UserData');
      kpf_zeilen  = kpf_zei{1};
      kpf_spalten = kpf_zei{2};
      kpf_stck    = kpf_zei{3};
      kpf_zeinr   = kpf_stck(length(kpf_stck)) + kpf_zeilen - 1;
      frewind(kpf_fid)
      for kpf_k=1:kpf_zeinr  kpf_zeile1 = fgets(kpf_fid); end
      kpf_zeile = fgets(kpf_fid);
      kpf_zeinr = kpf_zeinr + 1;
      
      if feof(kpf_fid) break; end
      kpf_stck = [kpf_stck  kpf_zeinr];
      
% neues Textfenster darstellen
      kpf_markerflag = 2;
      kpf_mzeile = 0;
      kpf_lznr = 1;      
      kpf_mx  = findstr('%MSV',kpf_zeile);
      if ~isempty(kpf_mx) kpf_za = kpf_mx+4; else kpf_za = 1; end
      kpf_te = min(findstr('%<',kpf_zeile));
      if isempty(kpf_te) kpf_lz = length(kpf_zeile); else kpf_lz = kpf_te - 1; end
      if iscomment(kpf_zeile)==1
         kpf_th = text(1,-kpf_lznr,kpf_zeile(2:kpf_lz),'FontSize',MSVTEXTSIZE,...
                       'FontName',MSVTEXTFONT,'FontWeight',MSVTEXTWEIGHT,'FontAngle',MSVTEXTANGLE);
      elseif iscomment(kpf_zeile)==3
         kpf_th = text(1,-kpf_lznr,kpf_zeile(3:kpf_lz),'Color',MSVKOMTCOLOR,'FontSize',MSVKOMTSIZE,...
                       'FontName',MSVKOMTFONT,'FontAngle',MSVKOMTANGLE,'FontWeight',MSVKOMTWEIGHT);
      elseif iscomment(kpf_zeile)==2
         kpf_th = text(1,-kpf_lznr,kpf_zeile(1:kpf_lz),'Color',kpf_pcolor,'Interpreter','none',...
                       'FontSize',MSVCODESIZE,'FontName',MSVCODEFONT);
      else
         kpf_th = text(1,-kpf_lznr,kpf_zeile(kpf_za:kpf_lz),'FontSize',MSVCODESIZE,'FontWeight',MSVCODEWEIGHT,'Interpreter','none',...
                       'FontName',MSVCODEFONT,'Color',MSVMARKCOLOR,'FontAngle',MSVCODEANGLE,'ButtonDownFcn','msvmarkbdf');
         if ~isempty(kpf_mx) 
            set(kpf_th,'Color',MSVMARKCOLOR,'FontName',MSVMSVFONT,'FontSize',MSVMSVSIZE,...
               'FontWeight',MSVMSVWEIGHT,'FontAngle',MSVMSVANGLE); 
         end
         text(-1,-kpf_lznr,'|','FontSize',MSVCODESIZE+8,'Color',MSVMARKCOLOR,'FontWeight','bold');
         kpf_mzeile = kpf_zeinr;  
         kpf_markerflag = 1;   
      end
      msvsetprop(kpf_zeile,kpf_th)
if kpf_such  msvsuchmark(kpf_th,kpf_zeile,kpf_lznr); end
      kpf_lznr  = kpf_lznr + 1;
      while ~feof(kpf_fid)&kpf_lznr<=kpf_zeilen
         kpf_zeile = fgets(kpf_fid);
         kpf_zeinr = kpf_zeinr+1;
         kpf_mx  = findstr('%MSV',kpf_zeile);
         if ~isempty(kpf_mx) kpf_za = kpf_mx+4; else kpf_za = 1; end
         kpf_te = min(findstr('%<',kpf_zeile));
         if isempty(kpf_te) kpf_lz = length(kpf_zeile); else kpf_lz = kpf_te - 1; end
         if iscomment(kpf_zeile)==1
            kpf_th = text(1,-kpf_lznr,kpf_zeile(2:kpf_lz),'FontSize',MSVTEXTSIZE,'FontName',MSVTEXTFONT,...
                           'FontWeight',MSVTEXTWEIGHT,'FontAngle',MSVTEXTANGLE);
            if kpf_markerflag==1  kpf_markerflag = 0; end     
         elseif iscomment(kpf_zeile)==3
            kpf_th = text(1,-kpf_lznr,kpf_zeile(3:kpf_lz),'Color',MSVKOMTCOLOR,'FontSize',MSVKOMTSIZE,...
                          'FontName',MSVKOMTFONT,'FontAngle',MSVKOMTANGLE);
            if kpf_markerflag==1  kpf_markerflag = 0; end     
         elseif iscomment(kpf_zeile)==2
            kpf_th = text(1,-kpf_lznr,kpf_zeile(1:kpf_lz),'Color',kpf_pcolor,'Interpreter','none',...
                          'FontSize',MSVCODESIZE,'FontName',MSVCODEFONT);
            if kpf_markerflag==1  kpf_markerflag = 0; end     
         else
            if kpf_markerflag
               text(-1,-kpf_lznr,'|','FontSize',MSVCODESIZE+8,'Color',MSVMARKCOLOR,'FontWeight','bold'); 
               kpf_th = text(1,-kpf_lznr,kpf_zeile(kpf_za:kpf_lz),'FontSize',MSVCODESIZE,'FontWeight',MSVCODEWEIGHT,'Interpreter','none',...
                             'FontName',MSVCODEFONT,'Color',MSVMARKCOLOR,'FontAngle',MSVCODEANGLE,'ButtonDownFcn','msvmarkbdf');
            else
               kpf_th = text(1,-kpf_lznr,kpf_zeile(kpf_za:kpf_lz),'FontSize',MSVCODESIZE,'FontName',MSVCODEFONT,'Interpreter','none',...
                             'Color',MSVCODECOLOR,'FontWeight',MSVCODEWEIGHT,'FontAngle',MSVCODEANGLE,'ButtonDownFcn','msvtextbdf');
            end     
            if ~isempty(kpf_mx) 
               set(kpf_th,'Color',MSVMSVCOLOR,'FontName',MSVMSVFONT,'FontSize',MSVMSVSIZE,'FontWeight',MSVMSVWEIGHT,'FontAngle',MSVMSVANGLE); 
               if kpf_markerflag  set(kpf_th,'Color',MSVMARKCOLOR); end   
            end
            if kpf_markerflag==2  
               kpf_mzeile = kpf_zeinr;  
               kpf_markerflag = 1; 
            end
         end
         msvsetprop(kpf_zeile,kpf_th)
if kpf_such  msvsuchmark(kpf_th,kpf_zeile,kpf_lznr); end
         kpf_lznr  = kpf_lznr + 1;
      end
      
      set(findobj('Type','uicontrol','Parent',gcf,'String','zurck'),'visible','on','CallBack','msvback')
      if feof(kpf_fid)
         set(findobj('Type','uicontrol','Parent',gcf,'String','weiter'),'visible','off','CallBack','nooperation')
      end
      
      if kpf_stck(length(kpf_stck))==kpf_mzeile
         % Anfang des geklickten MATLAB-Blocks suchen
         frewind(kpf_fid)
         bdf_anfang = 0;
         kpf_comm = 1;
         for kpf_k=1:kpf_mzeile
            kpf_zeile = fgetl(kpf_fid);
            kpf_ismat = ~iscomment(kpf_zeile);
            if kpf_ismat&kpf_comm  kpf_anfang = kpf_k; end
            kpf_comm = ~kpf_ismat;
         end
         % kpf_mzeile auf diesen Anfang setzen
         kpf_mzeile = kpf_anfang;
      end

      set(kpf_ta,'UserData',{kpf_zeilen; kpf_spalten; kpf_stck; kpf_mzeile});     

   case '+'
% Nchstes Textfenster darstellen
      delete(get(kpf_ta,'children'))
      kpf_fid = get(kpf_tf,'UserData');
      kpf_zei = get(kpf_ta,'UserData');
      kpf_zeilen  = kpf_zei{1};
      kpf_spalten = kpf_zei{2};
      kpf_stck    = kpf_zei{3};
      kpf_zeinr   = kpf_stck(length(kpf_stck));
      frewind(kpf_fid)
      for kpf_k=1:kpf_zeinr  kpf_zeile1 = fgets(kpf_fid); end
      kpf_zeile = fgets(kpf_fid);
      kpf_zeinr = kpf_zeinr + 1;
      
% Anfang fr nchstes Textfenster suchen
      kpf_lznr  = 1;
      while (~feof(kpf_fid))&(kpf_lznr<=(kpf_zeilen-2)) ...
            &((iscomment(kpf_zeile1)&iscomment(kpf_zeile))...
              |((~iscomment(kpf_zeile1)&(~iscomment(kpf_zeile)))))
         kpf_zeile = fgets(kpf_fid);
         kpf_lznr  = kpf_lznr + 1;
         kpf_zeinr = kpf_zeinr + 1;
      end
      
      if feof(kpf_fid) break; end
      kpf_stck = [kpf_stck  kpf_zeinr];
      
% neues Textfenster darstellen
      kpf_trenn = kpf_stck(length(kpf_stck))-kpf_stck(max([length(kpf_stck)-1,1]));
      if kpf_trenn>0&kpf_trenn-kpf_zeilen<0
         kpf_patch = patch([-5 72 72 -5],[(kpf_trenn-kpf_zeilen)*[1 1],0 0],0.9*[1 1 1]);
         set(kpf_patch,'EdgeColor','none')
      end   
      kpf_markerflag = 2;
      kpf_mzeile = 0;
      kpf_lznr = 1;      
      kpf_mx  = findstr('%MSV',kpf_zeile);
      if ~isempty(kpf_mx) kpf_za = kpf_mx+4; else kpf_za = 1; end
      kpf_te = min(findstr('%<',kpf_zeile));
      if isempty(kpf_te) kpf_lz = length(kpf_zeile); else kpf_lz = kpf_te - 1; end
      if iscomment(kpf_zeile)==1
         kpf_th = text(1,-kpf_lznr,kpf_zeile(2:kpf_lz),'FontSize',MSVTEXTSIZE,'FontName',MSVTEXTFONT,'Color',MSVTEXTCOLOR,...
                        'FontWeight',MSVTEXTWEIGHT,'FontAngle',MSVTEXTANGLE);
      elseif iscomment(kpf_zeile)==3
         kpf_th = text(1,-kpf_lznr,kpf_zeile(3:kpf_lz),'Color',MSVKOMTCOLOR,'FontSize',MSVKOMTSIZE,'FontName',MSVKOMTFONT,...
                       'FontWeight',MSVKOMTWEIGHT,'FontAngle',MSVKOMTANGLE);
      elseif iscomment(kpf_zeile)==2
         kpf_th = text(1,-kpf_lznr,kpf_zeile(1:kpf_lz),'Color',kpf_pcolor,'Interpreter','none',...
                       'FontSize',MSVCODESIZE,'FontName',MSVCODEFONT);
      else
         kpf_th = text(1,-kpf_lznr,kpf_zeile(kpf_za:kpf_lz),'FontSize',MSVCODESIZE,'FontWeight',MSVCODEWEIGHT,'Interpreter','none',...
                       'FontName',MSVCODEFONT,'Color',MSVMARKCOLOR,'FontAngle',MSVCODEANGLE,'ButtonDownFcn','msvmarkbdf');
         if ~isempty(kpf_mx) 
            set(kpf_th,'Color',MSVMARKCOLOR,'FontName',MSVMSVFONT,'FontSize',MSVMSVSIZE,'FontWeight',MSVMSVWEIGHT,'FontAngle',MSVMSVANGLE); 
         end
         text(-1,-kpf_lznr,'|','FontSize',MSVCODESIZE+8,'Color',MSVMARKCOLOR,'FontWeight','bold');
         kpf_mzeile = kpf_zeinr;  
         kpf_markerflag = 1;   
      end
      msvsetprop(kpf_zeile,kpf_th)
if kpf_such  msvsuchmark(kpf_th,kpf_zeile,kpf_lznr); end
      kpf_lznr  = kpf_lznr + 1;
      while ~feof(kpf_fid)&kpf_lznr<=kpf_zeilen
         kpf_zeile = fgets(kpf_fid);
         kpf_zeinr = kpf_zeinr+1;
         kpf_mx  = findstr('%MSV',kpf_zeile);
         if ~isempty(kpf_mx) kpf_za = kpf_mx+4; else kpf_za = 1; end
         kpf_te = min(findstr('%<',kpf_zeile));
         if isempty(kpf_te) kpf_lz = length(kpf_zeile); else kpf_lz = kpf_te - 1; end
         if iscomment(kpf_zeile)==1
            kpf_th = text(1,-kpf_lznr,kpf_zeile(2:kpf_lz),'FontSize',MSVTEXTSIZE,'FontName',MSVTEXTFONT,...
                          'Color',MSVTEXTCOLOR,'FontWeight',MSVTEXTWEIGHT,'FontAngle',MSVTEXTANGLE);
            if kpf_markerflag==1  kpf_markerflag = 0; end     
         elseif iscomment(kpf_zeile)==3
            kpf_th = text(1,-kpf_lznr,kpf_zeile(3:kpf_lz),'Color',MSVKOMTCOLOR,'FontSize',MSVKOMTSIZE,...
                          'FontName',MSVKOMTFONT,'FontWeight',MSVKOMTWEIGHT,'FontAngle',MSVKOMTANGLE);
            if kpf_markerflag==1  kpf_markerflag = 0; end     
         elseif iscomment(kpf_zeile)==2
            kpf_th = text(1,-kpf_lznr,kpf_zeile(1:kpf_lz),'Color',kpf_pcolor,'Interpreter','none',...
                          'FontSize',MSVCODESIZE,'FontName',MSVCODEFONT);
            if kpf_markerflag==1  kpf_markerflag = 0; end     
         else
            if kpf_markerflag
               text(-1,-kpf_lznr,'|','FontSize',MSVCODESIZE+8,'Color',MSVMARKCOLOR,'FontWeight','bold'); 
               kpf_th = text(1,-kpf_lznr,kpf_zeile(kpf_za:kpf_lz),'FontSize',MSVCODESIZE,'FontWeight',MSVCODEWEIGHT,'Interpreter','none',...
                             'FontName',MSVCODEFONT,'Color',MSVMARKCOLOR,'FontAngle',MSVCODEANGLE,'ButtonDownFcn','msvmarkbdf');
            else
               kpf_th = text(1,-kpf_lznr,kpf_zeile(kpf_za:kpf_lz),'FontSize',MSVCODESIZE,'FontName',MSVCODEFONT,'Interpreter','none',...
                             'Color',MSVCODECOLOR,'FontWeight',MSVCODEWEIGHT,'FontAngle',MSVCODEANGLE,'ButtonDownFcn','msvtextbdf');
            end     
            if ~isempty(kpf_mx) 
               set(kpf_th,'Color',MSVMSVCOLOR,'FontName',MSVMSVFONT,'FontSize',MSVMSVSIZE,'FontWeight',MSVMSVWEIGHT,'FontAngle',MSVMSVANGLE); 
               if kpf_markerflag  set(kpf_th,'Color',MSVMARKCOLOR); end   
            end
            if kpf_markerflag==2  
               kpf_mzeile = kpf_zeinr;  
               kpf_markerflag = 1; 
            end
         end
         msvsetprop(kpf_zeile,kpf_th)
if kpf_such  msvsuchmark(kpf_th,kpf_zeile,kpf_lznr); end
         kpf_lznr  = kpf_lznr + 1;
      end
      
      set(findobj('Type','uicontrol','Parent',gcf,'String','zurck'),'visible','on','CallBack','msvback')
      if feof(kpf_fid)
         set(findobj('Type','uicontrol','Parent',gcf,'String','weiter'),'visible','off','CallBack','nooperation')
      end
      
      if kpf_stck(length(kpf_stck))==kpf_mzeile
         % Anfang des geklickten MATLAB-Blocks suchen
         frewind(kpf_fid)
         bdf_anfang = 0;
         kpf_comm = 1;
         for kpf_k=1:kpf_mzeile
            kpf_zeile = fgetl(kpf_fid);
            kpf_ismat = ~iscomment(kpf_zeile);
            if kpf_ismat&kpf_comm  kpf_anfang = kpf_k; end
            kpf_comm = ~kpf_ismat;
         end
         % kpf_mzeile auf diesen Anfang setzen
         kpf_mzeile = kpf_anfang;
      end

      set(kpf_ta,'UserData',{kpf_zeilen; kpf_spalten; kpf_stck; kpf_mzeile});     
      
   case {'-','l'}
% voriges Textfenster darstellen
      delete(get(kpf_ta,'children'))
      kpf_fid = get(kpf_tf,'UserData');
      kpf_zei = get(kpf_ta,'UserData');
      kpf_zeilen  = kpf_zei{1};
      kpf_spalten = kpf_zei{2};
      kpf_stck    = kpf_zei{3};
      kpf_topstck = kpf_stck(length(kpf_stck));
      kpf_stck    = kpf_stck(1:max([1,length(kpf_stck)-1]));
      kpf_zeinr   = kpf_stck(length(kpf_stck));
      frewind(kpf_fid)
      for kpf_k=1:kpf_zeinr  kpf_zeile = fgets(kpf_fid); end
      kpf_lznr = 1;      
      
      kpf_trenn = kpf_topstck-kpf_stck(length(kpf_stck));
      if kpf_trenn>=0&kpf_trenn<=kpf_zeilen
         kpf_patch = patch([-5 72 72 -5],[-kpf_trenn*[1 1],-kpf_zeilen*[1 1]],0.9*[1 1 1]);
         set(kpf_patch,'EdgeColor','none')
      end   
      
      kpf_markerflag = 2;
      kpf_mzeile = 0;
      kpf_mx  = findstr('%MSV',kpf_zeile);
      if ~isempty(kpf_mx) kpf_za = kpf_mx+4; else kpf_za = 1; end
      kpf_te = min(findstr('%<',kpf_zeile));
      if isempty(kpf_te) kpf_lz = length(kpf_zeile); else kpf_lz = kpf_te - 1; end
      if iscomment(kpf_zeile)==1
         kpf_th = text(1,-kpf_lznr,kpf_zeile(2:kpf_lz),'FontSize',MSVTEXTSIZE,'FontName',MSVTEXTFONT,...
                       'COLOR',MSVTEXTCOLOR,'FontWeight',MSVTEXTWEIGHT,'FontAngle',MSVTEXTANGLE);
      elseif iscomment(kpf_zeile)==3
         kpf_th = text(1,-kpf_lznr,kpf_zeile(3:kpf_lz),'Color',MSVKOMTCOLOR,'FontSize',MSVKOMTSIZE,...
                       'FontName',MSVKOMTFONT,'FontAngle',MSVKOMTANGLE,'FontAngle',MSVKOMTANGLE);
      elseif iscomment(kpf_zeile)==2
         kpf_th = text(1,-kpf_lznr,kpf_zeile(1:kpf_lz),'Color',kpf_pcolor,'Interpreter','none',...
                       'FontSize',MSVCODESIZE,'FontName',MSVCODEFONT);
      else
         kpf_th = text(1,-kpf_lznr,kpf_zeile(kpf_za:kpf_lz),'FontSize',MSVCODESIZE,'FontWeight',MSVCODEWEIGHT,'Interpreter','none',...
                       'FontName',MSVCODEFONT,'Color',MSVMARKCOLOR,'FontAngle',MSVCODEANGLE,'ButtonDownFcn','msvmarkbdf');
         if ~isempty(kpf_mx) 
            set(kpf_th,'Color',MSVMARKCOLOR,'FontName',MSVMSVFONT,'FontSize',MSVMSVSIZE,'FontWeight',MSVMSVWEIGHT,'FontAngle',MSVMSVANGLE); 
         end
         text(-1,-kpf_lznr,'|','FontSize',MSVCODESIZE+8,'Color',MSVMARKCOLOR,'FontWeight','bold'); 
         kpf_mzeile = kpf_zeinr;  
         kpf_markerflag = 1;   
      end
      msvsetprop(kpf_zeile,kpf_th)
if kpf_such  msvsuchmark(kpf_th,kpf_zeile,kpf_lznr); end
      kpf_lznr  = kpf_lznr + 1;
      while ~feof(kpf_fid)&kpf_lznr<=kpf_zeilen
         kpf_zeile = fgets(kpf_fid);
         kpf_zeinr = kpf_zeinr+1;
         kpf_mx  = findstr('%MSV',kpf_zeile);
         if ~isempty(kpf_mx) kpf_za = kpf_mx+4; else kpf_za = 1; end
         kpf_te = min(findstr('%<',kpf_zeile));
         if isempty(kpf_te) kpf_lz = length(kpf_zeile); else kpf_lz = kpf_te - 1; end
         if iscomment(kpf_zeile)==1
            kpf_th = text(1,-kpf_lznr,kpf_zeile(2:kpf_lz),'FontSize',MSVTEXTSIZE,'FontName',MSVTEXTFONT,...
                          'Color',MSVTEXTCOLOR,'FontWeight',MSVTEXTWEIGHT,'FontAngle',MSVTEXTANGLE);
            if kpf_markerflag==1  kpf_markerflag = 0; end     
         elseif iscomment(kpf_zeile)==3
            kpf_th = text(1,-kpf_lznr,kpf_zeile(3:kpf_lz),'Color',MSVKOMTCOLOR,'FontSize',MSVKOMTSIZE,...
                          'FontName',MSVKOMTFONT,'FontWeight',MSVKOMTWEIGHT,'FontAngle',MSVKOMTANGLE);
            if kpf_markerflag==1  kpf_markerflag = 0; end     
         elseif iscomment(kpf_zeile)==2
            kpf_th = text(1,-kpf_lznr,kpf_zeile(1:kpf_lz),'Color',kpf_pcolor,'Interpreter','none',...
                          'FontSize',MSVCODESIZE,'FontName',MSVCODEFONT);
            if kpf_markerflag==1  kpf_markerflag = 0; end     
         else
            if kpf_markerflag
               text(-1,-kpf_lznr,'|','FontSize',MSVCODESIZE+8,'Color',MSVMARKCOLOR,'FontWeight','bold'); 
               kpf_th = text(1,-kpf_lznr,kpf_zeile(kpf_za:kpf_lz),'FontSize',MSVCODESIZE,'FontWeight',MSVCODEWEIGHT,'Interpreter','none',...
                              'FontName',MSVCODEFONT,'Color',MSVMARKCOLOR,'FontAngle',MSVCODEANGLE,'ButtonDownFcn','msvmarkbdf');
            else
               kpf_th = text(1,-kpf_lznr,kpf_zeile(kpf_za:kpf_lz),'FontSize',MSVCODESIZE,'FontName',MSVCODEFONT,'Interpreter','none',...
                             'Color',MSVCODECOLOR,'FontWeight',MSVCODEWEIGHT,'FontAngle',MSVCODEANGLE,'ButtonDownFcn','msvtextbdf');
            end     
            if ~isempty(kpf_mx) 
               set(kpf_th,'Color',MSVMSVCOLOR,'FontName',MSVMSVFONT,'FontSize',MSVMSVSIZE,'FontWeight',MSVMSVWEIGHT,'FontAngle',MSVMSVANGLE); 
               if kpf_markerflag  set(kpf_th,'Color',MSVMARKCOLOR); end   
            end
            if kpf_markerflag==2  
               kpf_mzeile = kpf_zeinr;  
               kpf_markerflag = 1; 
            end
         end
         msvsetprop(kpf_zeile,kpf_th)
if kpf_such  msvsuchmark(kpf_th,kpf_zeile,kpf_lznr); end
         kpf_lznr  = kpf_lznr + 1;
      end
      
      if kpf_stck(length(kpf_stck))==kpf_mzeile
         % Anfang des geklickten MATLAB-Blocks suchen
         frewind(kpf_fid)
         bdf_anfang = 0;
         kpf_comm = 1;
         for kpf_k=1:kpf_mzeile
            kpf_zeile = fgetl(kpf_fid);
            kpf_ismat = ~iscomment(kpf_zeile);
            if kpf_ismat&kpf_comm  kpf_anfang = kpf_k; end
            kpf_comm = ~kpf_ismat;
         end
         % kpf_mzeile auf diesen Anfang setzen
         kpf_mzeile = kpf_anfang;
      end
      
      set(kpf_ta,'UserData',{kpf_zeilen; kpf_spalten; kpf_stck; kpf_mzeile});    

      set(findobj('Type','uicontrol','Parent',gcf,'String','weiter'),'visible','on','CallBack','msvforw')
      if kpf_stck==1
         set(findobj('Type','uicontrol','Parent',gcf,'String','zurck'),'visible','off','CallBack','nooperation')
      end
      
   case 'v'
% Darstellen des markierten Skriptes in einem neuen mscriptview-Fenster
      kpf_fid = get(kpf_tf,'UserData');
      kpf_zei = get(kpf_ta,'UserData');
      kpf_mzeile = kpf_zei{4};
      frewind(kpf_fid)
      for kpf_k=1:kpf_mzeile  kpf_zeile = fgetl(kpf_fid); end
      
% MATLAB-Skript in mscriptview darstellen
      mscriptview(kpf_zeile)      
      
   case 's'
% Suchen nach einem jetzt einzugebenden Stichwort
      stext = inputdlg('hier das gesuchte Stichwort eingeben','Suchwort');
      MSVSUCHTEXT = stext{1};
      
end
   
if kpf_cc==27 msvdelfig; end

if kpf_cc==127 
   fclose(get(gcf,'UserData'));
   delete(gcf)
end

set(findobj('Type','text','Parent',kpf_ta),'VerticalAlignment','baseline')

set(kpf_tf,'Pointer','arrow')
