function msvsuchmark(th,zeile,zeinr)
% msvsuchmark(th,zeile,zeinr)
% Im String Zeile wird der String MSVSUCHTEXT gesucht und gegebenenfalls 
% im Textobjekt mit dem Handle th durch Unterstrich markiert.
% Enthlt zeile einen Link, so wird zeile nach "%MSV" durchsucht.
% Falls dieser Titel des Links den String MSVSUCHTEXT nicht enthlt, 
% wird der Link bis in die Bltter traversiert und links mit einem 
% Pfeil markiert, falls eines der Bltter den MSVSUCHTEXT enthlt.
% Damit die Suche auch im Falle von Zyklen in der Linkstruktur terminiert 
% wird die Tiefe der Rekursion beschrnkt.

% Globale Konstanten
% ==================
global MSVTITLFONT MSVTITLWEIGHT MSVTITLSIZE MSVTITLCOLOR MSVTITLANGLE
global MSVTEXTFONT MSVTEXTWEIGHT MSVTEXTSIZE MSVTEXTCOLOR MSVTEXTANGLE
global MSVKOMTFONT MSVKOMTWEIGHT MSVKOMTSIZE MSVKOMTCOLOR MSVKOMTANGLE
global MSVCODEFONT MSVCODEWEIGHT MSVCODESIZE MSVCODECOLOR MSVCODEANGLE
global MSVFORMFONT MSVFORMWEIGHT MSVFORMSIZE MSVFORMCOLOR MSVFORMANGLE
global MSVMSVFONT MSVMSVWEIGHT MSVMSVSIZE MSVMSVCOLOR MSVMSVANGLE 
global MSVMARKCOLOR MSVSUCHCOLOR MSVSUCHTEXT MSVZEILEN MSVSPALTEN MSVBUSY

k   = findstr('%MSV',zeile);

if iscomment(zeile)==1
   ix = findstr(upper(MSVSUCHTEXT),upper(zeile));
   if ~isempty(ix)
      tfn = get(th,'FontName');
      tfs = get(th,'FontSize');
      tfw = get(th,'FontWeight');
      tfa = get(th,'FontAngle');
      tps = get(th,'Position');
      thh = text(tps(1),tps(2),klammerzu(zeile(2:ix(1)-1),3),'FontSize',tfs,'FontName',tfn,...
                 'FontWeight',tfw,'FontAngle',MSVTEXTANGLE,'visible','off');
      msvsetprop(zeile,thh)        
      ext = get(thh,'extent');
      ths = text(tps(1)+ext(3),tps(2),klammerzu(zeile(2:ix(1)+length(MSVSUCHTEXT)-1),3),'FontSize',tfs,'FontName',tfn,...
                 'FontWeight',tfw,'FontAngle',MSVTEXTANGLE,'visible','off');
      msvsetprop(zeile,ths)        
      exs = get(ths,'extent');
      uln = line([ext(1)+ext(3) ext(1)+exs(3)],(exs(2)+0.3)*[1 1],'Color',MSVSUCHCOLOR,'LineWidth',3);        
      text(-1,-zeinr,'\rightarrow','Color',MSVSUCHCOLOR,'FontSize',MSVTEXTSIZE+5,'FontWeight','bold','VerticalAlignment','baseline');
   end   
elseif iscomment(zeile)==3
   ix = findstr(upper(MSVSUCHTEXT),upper(zeile));
   if ~isempty(ix)
      tfn = MSVKOMTFONT;
      tfs = MSVKOMTSIZE;
      tfw = MSVKOMTWEIGHT;
      tfa = MSVKOMTANGLE;
      tps = get(th,'Position');
      thh = text(tps(1),tps(2),klammerzu(zeile(3:ix(1)-1),3),'FontSize',tfs,'FontName',tfn,...
                 'FontWeight',tfw,'FontAngle',tfa,'visible','off');
      ext = get(thh,'extent');
      ths = text(tps(1)+ext(3),tps(2),klammerzu(zeile(3:ix(1)+length(MSVSUCHTEXT)-1),3),'FontSize',tfs,'FontName',tfn,...
                 'FontWeight',tfw,'FontAngle',tfa,'visible','off');
      exs = get(ths,'extent');
      uln = line([ext(1)+ext(3) ext(1)+exs(3)],(exs(2)+0.3)*[1 1],'Color',MSVSUCHCOLOR,'LineWidth',3);        
      text(-1,-zeinr,'\rightarrow','Color',MSVSUCHCOLOR,'FontSize',MSVKOMTSIZE+5,'FontWeight','bold','VerticalAlignment','baseline');
   end   
elseif length(k)>0
   k = k(1);
   ix = findstr(upper(MSVSUCHTEXT),upper(zeile(k+4:end)));
   if ~isempty(ix)
      tfn = get(th,'FontName');
      tfs = get(th,'FontSize');
      tfw = get(th,'FontWeight');
      tfa = get(th,'FontAngle');
      tps = get(th,'Position');
      thh = text(tps(1),tps(2),klammerzu(zeile(k+4+(0:ix(1)-2)),3),'FontSize',tfs,'FontName',tfn,...
                 'FontWeight',tfw,'FontAngle',MSVTEXTANGLE,'visible','off');
      ext = get(thh,'extent');
      ths = text(tps(1),tps(2),klammerzu(zeile(k+4+(0:ix(1)-2+length(MSVSUCHTEXT))),3),'FontSize',tfs,'FontName',tfn,...
                 'FontWeight',tfw,'FontAngle',MSVTEXTANGLE,'visible','off');
      exs = get(ths,'extent');
      uln = line([ext(1)+ext(3) ext(1)+exs(3)],(exs(2)+0.3)*[1 1],'Color',MSVSUCHCOLOR,'LineWidth',3);        
      text(-1,-zeinr,'\rightarrow','Color',MSVSUCHCOLOR,'FontSize',MSVTEXTSIZE+5,'FontWeight','bold','VerticalAlignment','baseline');
   elseif length(mssearch(MSVSUCHTEXT,zeile(1:k-1),0))>0
      text(-1,-zeinr,'\rightarrow','Color',MSVSUCHCOLOR,'FontSize',MSVTEXTSIZE+5,'FontWeight','bold','VerticalAlignment','baseline');
   end
end
