% Skript als ButtonDownFunction fr nicht markierte Textobjekte.
%
% Der geklickte MATLAB-Block wird markiert.
%
% Alle Variablennamen beginnen mit  bdf_

% Autor: Klaus von der Heide, e-mail:  v.d.heide@on-line.de


% Globale Konstanten
% ==================
global MSVTITLFONT MSVTITLWEIGHT MSVTITLSIZE MSVTITLCOLOR MSVTITLANGLE
global MSVTEXTFONT MSVTEXTWEIGHT MSVTEXTSIZE MSVTEXTCOLOR MSVTEXTANGLE
global MSVKOMTFONT MSVKOMTWEIGHT MSVKOMTSIZE MSVKOMTCOLOR MSVKOMTANGLE
global MSVCODEFONT MSVCODEWEIGHT MSVCODESIZE MSVCODECOLOR MSVCODEANGLE
global MSVFORMFONT MSVFORMWEIGHT MSVFORMSIZE MSVFORMCOLOR MSVFORMANGLE
global MSVMSVFONT MSVMSVWEIGHT MSVMSVSIZE MSVMSVCOLOR MSVMSVANGLE 
global MSVMARKCOLOR MSVSUCHCOLOR MSVSUCHTEXT MSVZEILEN MSVSPALTEN MSVBUSY

if isempty(MSVTITLFONT)  msvinit; end

% Lokale Konstanten
% =================
if isempty(MSVSUCHTEXT) bdf_such = 0; else bdf_such = 1; end
bdf_pcolor   = 'w';                     % Color fr pause-Kommandos u..
bdf_tf  = gcf;
bdf_ta  = gca;
bdf_cp  = get(bdf_ta,'CurrentPoint');
bdf_cy  = - round(bdf_cp(1,2)-0.3);     % geklickte Zeile im Textfenster
bdf_fid = get(bdf_tf,'UserData');
bdf_zei = get(bdf_ta,'UserData');
bdf_zeilen  = bdf_zei{1};
bdf_spalten = bdf_zei{2};
kpf_bdck    = bdf_zei{3};
bdf_stck  = bdf_zei{3};
bdf_zeinr = bdf_stck(length(bdf_stck)); % Zeilennummer der obersten Zeile
bdf_kzei  = bdf_zeinr + bdf_cy - 1;     % geklickte Zeile
frewind(bdf_fid)

if isempty(MSVSUCHTEXT) 
   bdf_such = 0; 
else 
   bdf_such = 1; 
   set(bdf_tf,'Pointer','watch')
end

%
% Anfang des geklickten MATLAB-Blocks suchen
bdf_anfang = 0;
bdf_comm = 1;
for bdf_k=1:bdf_kzei
   bdf_zeile = fgetl(bdf_fid);
   bdf_ismat = ~iscomment(bdf_zeile);
   if bdf_ismat&bdf_comm  bdf_anfang = bdf_k; end
   bdf_comm = ~bdf_ismat;
end
%
% bdf_mzeile auf diesen Anfang setzen
bdf_mzeile = bdf_anfang;
set(bdf_ta,'UserData',{bdf_zeilen; bdf_spalten; bdf_stck; bdf_mzeile});
%
% Seite neu darstellen
delete(get(bdf_ta,'children'))
frewind(bdf_fid)
for bdf_k=1:bdf_zeinr  bdf_zeile = fgets(bdf_fid); end
bdf_zeinr = bdf_zeinr + 1;
bdf_lznr = 1;
bdf_mx  = findstr('%MSV',bdf_zeile);
if ~isempty(bdf_mx) bdf_za = bdf_mx+4; else bdf_za = 1; end
if bdf_mzeile<=bdf_zeinr  bdf_markerflag = 1; else bdf_markerflag = 0; end;
bdf_te = min(findstr('%<',bdf_zeile));
if isempty(bdf_te) bdf_lz = length(bdf_zeile); else bdf_lz = bdf_te - 1; end
if iscomment(bdf_zeile)==1
   bdf_th = text(1,-bdf_lznr,bdf_zeile(2:bdf_lz),'FontSize',MSVTEXTSIZE,'FontName',MSVTEXTFONT,...
                 'Color',MSVTEXTCOLOR,'FontWeight',MSVTEXTWEIGHT,'FontAngle',MSVTEXTANGLE);
elseif iscomment(bdf_zeile)==3
   bdf_th = text(1,-bdf_lznr,bdf_zeile(3:bdf_lz),'Color',MSVKOMTCOLOR,'FontSize',MSVKOMTSIZE,...
                 'FontName',MSVKOMTFONT,'FontAngle',MSVKOMTANGLE);
elseif iscomment(bdf_zeile)==2
   bdf_th = text(1,-bdf_lznr,bdf_zeile(1:bdf_lz),'Color',bdf_pcolor,...
                 'FontSize',MSVCODESIZE,'FontName',MSVCODEFONT);
elseif bdf_markerflag
   bdf_th = text(1,-bdf_lznr,bdf_zeile(bdf_za:bdf_lz),'FontSize',MSVCODESIZE,'FontWeight','bold','Interpreter','none',...
                  'FontName',MSVCODEFONT,'Color',MSVMARKCOLOR,'FontAngle',MSVCODEANGLE,'ButtonDownFcn','msvmarkbdf');
   text(-1,-bdf_lznr,'|','FontSize',MSVCODESIZE+8,'Color',MSVMARKCOLOR,'FontWeight','bold','ButtonDownFcn','msvmarkbdf');
   bdf_markerflag = 1;
else
   bdf_th = text(1,-bdf_lznr,bdf_zeile(bdf_za:bdf_lz),'FontSize',MSVCODESIZE,'FontWeight',MSVCODEWEIGHT,...
                 'FontName',MSVCODEFONT,'Color',MSVCODECOLOR,'ButtonDownFcn','msvtextbdf','Interpreter','none');
end              
if ~isempty(bdf_mx) & ~iscomment(bdf_zeile)
   set(bdf_th,'Color',MSVMSVCOLOR,'FontName',MSVMSVFONT,'FontSize',MSVMSVSIZE,'FontWeight',MSVMSVWEIGHT,'FontAngle',MSVMSVANGLE); 
   if bdf_markerflag==1 set(bdf_th,'Color',MSVMARKCOLOR); end  
end
msvsetprop(bdf_zeile,bdf_th)
if bdf_such  msvsuchmark(bdf_th,bdf_zeile,bdf_lznr); end
while ~feof(bdf_fid)&bdf_lznr<=bdf_zeilen-1
   bdf_zeile = fgets(bdf_fid);
   bdf_lznr  = bdf_lznr + 1;
   bdf_mx  = findstr('%MSV',bdf_zeile);
   if ~isempty(bdf_mx) bdf_za = bdf_mx+4; else bdf_za = 1; end
   bdf_te = min(findstr('%<',bdf_zeile));
   if isempty(bdf_te) bdf_lz = length(bdf_zeile); else bdf_lz = bdf_te - 1; end
   if iscomment(bdf_zeile)==1
      bdf_th = text(1,-bdf_lznr,bdf_zeile(2:bdf_lz),'FontSize',MSVTEXTSIZE,'FontName',MSVTEXTFONT,...
                    'Color',MSVTEXTCOLOR,'FontAngle',MSVTEXTANGLE);
      if bdf_markerflag==1  bdf_markerflag = 0; end     
   elseif iscomment(bdf_zeile)==3
      bdf_th = text(1,-bdf_lznr,bdf_zeile(3:bdf_lz),'Color',MSVKOMTCOLOR,'FontSize',MSVKOMTSIZE,...
                    'FontName',MSVKOMTFONT,'FontAngle',MSVKOMTANGLE);
      if bdf_markerflag==1  bdf_markerflag = 0; end     
   elseif iscomment(bdf_zeile)==2
      bdf_th = text(1,-bdf_lznr,bdf_zeile(1:bdf_lz),'Color',bdf_pcolor,...
                    'FontSize',MSVCODESIZE,'FontName',MSVCODEFONT);
      if bdf_markerflag==1  bdf_markerflag = 0; end     
   elseif bdf_zeinr==bdf_mzeile
      bdf_th = text(1,-bdf_lznr,bdf_zeile(bdf_za:bdf_lz),'FontSize',MSVCODESIZE,'FontWeight','bold','Interpreter','none',...
                     'FontName',MSVCODEFONT,'Color',MSVMARKCOLOR,'ButtonDownFcn','msvmarkbdf');
      text(-1,-bdf_lznr,'|','FontSize',MSVCODESIZE+8,'Color',MSVMARKCOLOR,'FontWeight','bold','ButtonDownFcn','msvmarkbdf');
      bdf_markerflag = 1;
   elseif bdf_markerflag
      bdf_th = text(1,-bdf_lznr,bdf_zeile(bdf_za:bdf_lz),'FontSize',MSVCODESIZE,'FontWeight','bold','Interpreter','none',...
                     'FontName',MSVCODEFONT,'Color',MSVMARKCOLOR,'ButtonDownFcn','msvmarkbdf');
      text(-1,-bdf_lznr,'|','FontSize',MSVCODESIZE+8,'Color',MSVMARKCOLOR,'FontWeight','bold','ButtonDownFcn','msvmarkbdf');
      bdf_markerflag = 1;
   else
      bdf_th = text(1,-bdf_lznr,bdf_zeile(bdf_za:bdf_lz),'FontSize',MSVCODESIZE,'FontName',MSVCODEFONT,...
                    'Color',MSVCODECOLOR,'FontWeight',MSVCODEWEIGHT,'ButtonDownFcn','msvtextbdf','Interpreter','none');
   end     
   if ~isempty(bdf_mx) & ~iscomment(bdf_zeile) 
      set(bdf_th,'Color',MSVMSVCOLOR,'FontName',MSVMSVFONT,'FontSize',MSVMSVSIZE,'FontWeight',MSVMSVWEIGHT,'FontAngle',MSVMSVANGLE);    
      if bdf_markerflag==1 set(bdf_th,'Color',MSVMARKCOLOR); end  
   end   
   msvsetprop(bdf_zeile,bdf_th)
if bdf_such  msvsuchmark(bdf_th,bdf_zeile,bdf_lznr); end
   bdf_zeinr = bdf_zeinr+1;
end

set(findobj('Type','text','Parent',bdf_ta),'VerticalAlignment','baseline')

set(bdf_tf,'Pointer','arrow')

