function x0 = num2basstr(z,basis,n)
%  x0 = num2basstr(z,basis,n)
%  wandelt die natrliche Zahl z in einen String, der die 
%  Stellendarstellung von z bezglich der Basis basis enthlt. 
%  Falls die Stellenzahl n nicht angegeben ist, werden fhrende 
%  Nullen weggelassen. 
%  Warnung:  es werden nur die letzten n Stellen ausgegeben!

%  Autor:  Klaus von der Heide,  v.d.heide@on-line.de
%
if z<0 error('num2basstr: z < 0'); end
if z~=round(z) error('num2basstr: z ist nicht natrliche Zahl'); end
if ~ismember(basis,2:16) error('num2basstr: Basis nicht aus 2:16'); end
d = z;
str = '';
while d~=0
   r = rem(d,basis);
   d = floor(d/basis);
   str = [charziffer(r),str];
end
if length(str)==0 str = '0'; end
if nargin>2
   lstr = length(str);
   if lstr>n  str = str(lstr-n+1:lstr);
   else for k=1:n-length(str) str = ['0' str]; end; 
   end
end
x0 = str;
