function x0 = num2basstr2(z,basis,n,m)
%  x0 = num2basstr2(z,basis,n,m)
%  wandelt die Zahl z in einen String, der die Stellendarstellung 
%  von z bezglich der Basis basis enthlt. 
%  Falls die Vorkommastellenzahl n nicht angegeben ist, werden 
%  fhrende Nullen weggelassen.  m ist die Nachkommastellenzahl.
%  Wenn z ein Spaltenvektor von natrlichen Zahlen ist, wird
%  eine entsprechende Matrix der Stellendarstellungen erzeugt.

%  Autor:  Klaus von der Heide,  v.d.heide@on-line.de

charzif = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
if (basis<2)|(basis>length(charzif)) error('num2basstr: Basis nicht aus 2:64'); end
if any(z<0) error('num2basstr: z < 0'); end
if nargin<3  n = max(1,ceil(log(max(z)+1)/log(basis))); end
if nargin<4  m = 0; end

z = floor(z*basis^m);

for j=1:length(z)
   d = z(j);
   str = '';
   while d~=0
      r = rem(d,basis);
      d = floor(d/basis);
      str = [charzif(r+1),str];
   end
   lstr = length(str);
   if lstr>n+m  
      str = str(lstr-n+1:lstr);
   else 
      for k=1:n+m-length(str) str = ['0' str]; end; 
   end
   if m>0
      x0(j,:) = [str(1:end-m) '.' str(end-m+1:end)]; 
   else
      x0(j,:) = str;
   end
end
   