function v = num2basvec(z,basis,n)
%  v = num2basvec(z,basis,n)
%  wandelt die natrliche Zahl z in einen Vektor, der die 
%  Stellendarstellung von z bezglich der Basis basis enthlt. 
%  n ist die Stellenzahl.
%  Die Darstellung erfolgt modulo basis^n. Negative z werden also 
%  im basis-Komplement dargestellt.
%  int2gf(z,n,basis) tut das selbe, jedoch auch fr Spaltenvektoren z.

%  Autor:  Klaus von der Heide,  v.d.heide@on-line.de

if nargin<3  n = max(1,ceil(log(z+1)/log(basis))); end

v  = mod(floor(z./reverse([1 cumprod(basis*ones(1,n-1))])),basis);



