function binmat = num2binmat(z,n)
% binmat = num2binmat(z,n)

% wandelt die ganzen Zahlen des Spaltenvektors z in 
% binre Zeilenvektoren von n Bits. 
% Bei negativem z erhlt man das 2-Komplement.
% siehe auch: num2binvec

% Autor: Klaus von der Heide, e-mail:  v.d.heide@on-line.de

[nz,ns] = size(z);
if ns>1  error('num2binmat:  z darf nur eine Spalte haben'); end
if n==0  binmat = []; end
for k=1:nz
   if z(k)>=2^n         error('num2binmat :  Zahl zu gross fr n Bits'); end
   if z(k)<-2^(n-1)     error('num2binmat :  Zahl zu klein fr n Bits'); end
   if z(k)~=round(z(k)) error('num2binmat :  Zahlen mssen ganz sein');  end
   binmat(k,:) = mod(floor(z(k)./reverse([1 cumprod(2*ones(1,n-1))])),2);
end
