function binvec = num2binvec(z,n)
% binvec = num2binvec(z,n)

% wandelt die ganze Zahl z in einen binren Zeilenvektor 
% von n Bits. Bei negativem z erhlt man das 2-Komplement.
% siehe auch: num2basvec, int2gf

% Autor: Klaus von der Heide, e-mail:  v.d.heide@on-line.de

if z>=2^n      error('num2binvec :  Zahl zu gross fr n Bits'); end
if z<-2^(n-1)  error('num2binvec :  Zahl zu klein fr n Bits'); end
if n==0  
   binvec = [];
else
   binvec  = mod(floor(z./reverse([1 cumprod(2*ones(1,n-1))])),2);
end