function x = randb(n,w)
%  x = randb(n,w)
%  Erzeugung eines binren Zufallsvektors der Lnge n.
%  Standardmssig werden Sequenzen aus 0 und 1 erzeugt,
%  mit w = [a, b] werden Sequenzen von a und b erzeugt.
%  Fr n kann auch ein Vektor mit den zwei Komponenten
%  Zeilenzahl und Spaltenzahl eingesetzt werden. Dann 
%  wird eine entsprechende Matrix erzeugt.
%  Defaults:  n = 1;  w = [0 1]
%  Beispiele:  
%  randb, randb(8), randb([2 3]), randb([3 2],[-1 +1])

% Autor:  Klaus von der Heide  e-mail:  v.d.heide@on-line.de

if nargin<1  
   x = round(rand);
else
   if length(n)==2  
      m = n(1);  
      n = n(2); 
   else 
      m = 1; 
   end
   if nargin<2  
      x = round(rand(m,n));
   else
      x = w(1)*ones(m,n);
      x(find(rand(m,n)>0.5)) = w(2);
   end
end
