function [y,d] = real2analyt(x,g,q)
% [y,d] = real2analyt(x,g,q)
% real2analyt wandelt das reelle Signal x in das analytische 
% Signal y unter Verwendung eines Hilbertfilters vom Grad g.
% Das Filter hat den Durchlassbereich  q .. 1-q.
% Jeder zweite Koeffizient der Filter ist Null. Deshalb sind
% Filter mit mod(g,4)=0 gleich denen mit mod(g,4)=2.
% y ist gegenber x um d Abtastschritte verzgert.

% K. v. d. Heide,  e-mail:  v.d.heide@on-line.de
%
if nargin<3 q = 0.1; end
if nargin<2 g = 30;  end
if nargin<1 x = randn(1,512); end
b = remez(g,[q,1-q],[1 1],'Hilbert');   % Hilbertfilter
y = delay(x,g/2) + i*filter(b,1,x);     % analytisches Signal
d = g/2;
