function setfigpos(m,n,i,j,s)
% setfigpos(m,n,i,j,s)
% Das aktuell oben liegende Bild wird auf folgende Position gebracht:
% Der Bildschirm wird in eine m*n-Matrix gleich grosser Bilder zerlegt.
% i,j sind die Indices des gewhlten Bildes.
% m,n,i,j drfen reelle Zahlen sein, z.B. setfigpos(2,3,1.5,2.5)
% s = 0 : Kopfzeile und MenuBar liegen ausserhalb des berechneten Bildfeldes.
%
% Beispiel:
% m = 7;
% for u = m:-1:1  
%    for v = 1:u  
%        fh(u*(u-1)/2+v) = figure;
%        set(gcf,'Name',sprintf('Bild  %d / %d',u,v),'Color',[u/m,v/m,0]); 
%        setfigpos(m,u,u,v,0)
%    end
% end

if nargin<5   s = 1; end
if nargin<4   j = 1; end
if nargin<3   i = 1; end
if nargin<2   n = 1; end
if nargin<1   m = 1; end
ss = get(0,'ScreenSize');
fh = gcf;
mb = s + 2*strcmp(get(fh,'MenuBar'),'figure');
bl = 0.003;
bb = 1 - 2*bl;
switch mb
   case 0,
      bu = 0.046;
      bh = 0.93;
      hf = 0.99;
   case 1,
      bu = 0.046;
      bh = 0.96;
      hf = 1 - 0.035*m;
   case 2,
      bu = 0.046;
      bh = 0.868;
      hf = 1;
   case 3,
      bu = 0.046;
      bh = 0.96;
      hf = 1 - 0.1*m;
end 
set(fh,'Position',round([(bl+bb/n*(j-1))*ss(3),(bu+bh/m*(m-i))*ss(4),bb/n*ss(3),bh*hf/m*ss(4)]));    
