function sichtbarkeit
% Steuerung der Sichtbarkeit durch Eingabe ber die Tastatur:
% Drcken der Zifferntaste n bewirkt Toggeln der Sichbarkeit 
% aller line-Objekte mit 'UserData' = 10*gcf + n.
% Taste 0 toggelt einen Cursor, der mit + und - bewegt werden kann.
% "ESC" lscht alle Graphiken, "Entf" nur das obenliegende Bild.

% Autor: K. von der Heide, e-mail:  v.d.heide@on-line.de

c = get(gcf,'CurrentCharacter');                  % eingegebenes Zeichen
k = double(c) - 48;                               % eingegebene Ziffer
if (k>0)&(k<9)                                    % sonst falsche Eingabe
   ud = 10*gcf + k;                               % gesuchte UserData
   lo = findobj(gcf,'type','line','UserData',ud); % gesuchte Objekte
   for l=1:length(lo)
      switch get(lo(l),'Visible')
         case 'on',   set(lo(l),'Visible','off')
         case 'off',  set(lo(l),'Visible','on')
      end
   end
end
if c=='0'
   lo  = findobj(gcf,'type','line','MarkerSize',35); % das ist der Cursor
   if length(lo)>0
      switch get(lo(1),'Visible')
         case 'on',   set(lo(1),'Visible','off')
         case 'off',  set(lo(1),'Visible','on')
      end
   end
end
if (k==-3)|(k==-5)
   lo  = findobj(gcf,'type','line','MarkerSize',35); % das ist der Cursor
   if length(lo)>0
      ud  = get(lo(1),'UserData');                 % {Index; yd; zd}
      ind = ud{1};
      if k==-3
         ind = max([1,ind-1]);
      else
         ind = min([length(ud{2}),ind+1]);
      end
      ud{1} = ind;
      set(lo(1),'UserData',ud,...
          'XData',ind,'YData',ud{2}(ind),'ZData',ud{3}(ind))
   end
end
if c=='a'  axlimdlg; end
if (k==56)|(k==24)
   fs = 12;
   helpwin = figure;
   set(helpwin,'NumberTitle','off','Name','HelpWin',...
       'Color','w','MenuBar','none','Position',[4 333 407 360],...
       'KeyPressFcn','delete(gcf)','ButtonDownFcn','delete(gcf)')
   axis([0,80,1,15]); axis off
   text(0,14,'Das obenliegende Bild kann durch','FontSize',fs)
   text(0,13,'Tastatureingabe verndert werden:','FontSize',fs)
   text(0,11.5,'Taste   Wirkung','FontSize',fs)
   text(0,10,'  0     Toggeln der Sichtbarkeit eines Cursors','FontSize',fs)
   text(0,9,'  1     Toggeln der Sichtbarkeit der Line-Objekte 1','FontSize',fs)
   text(0,8,'  2     Toggeln der Sichtbarkeit der Line-Objekte 2','FontSize',fs)
   text(0,7,' usw. bis maximal 9','FontSize',fs)
   text(0,6,'  +     Bewegung des Cursors vorwrts','FontSize',fs)
   text(0,5,'  -     Bewegung des Cursors rckwrts','FontSize',fs)
   text(0,4,'  a     Dialogfenster fr Axeneinstellung','FontSize',fs)
   text(0,3,'  h     dieses Hilfe-Fenster erzeugen','FontSize',fs)
   text(0,2,'"Entf"  Lschen des Bildes','FontSize',fs)
   text(0,1,'"ESC"   Lschen aller Bilder','FontSize',fs)
end
if c=='m' set(gcf,'MenuBar','figure'); end
drawnow
if double(c)==27  msvdelfig;   end
if double(c)==127 delete(gcf); end
