function pfade = suchalle(datei,wurzel,teil)
% pfade = suchalle(datei,wurzel,teil)
% Ausgehend von der Wurzel wurzel wird nach der Datei oder dem Verzeichnis 
% datei gesucht und alle vollstndigen Pfade in der Struktur pfade zurckgegeben.
% Wird teil~=0 angegeben, so werden auch alle Dateien mit aufgelistet, deren Name 
% den String datei enthlt.
%
% datei  :  String mit dem Namen der Datei inklusive der Erweiterung
%           oder dem Namen eines Verzeichnisses oder einem Teil des 
%           Namens, wenn teil~=0
%
% wurzel :  String mit dem Pfad der Wurzel
%
% pfade  :  Struktur, die fr jede gefundene Datei ein structure array mit 
%           den Feldern Pfad, Datum, Bytes enthlt
%
% Beispiel:  suchalle('.ini','c:',1)

if nargin<2  wurzel = 'c:\'; end
if nargin<3    teil = 0; end
if ~(isdir(wurzel) | findstr(wurzel,'c:  d:  e:  f:'))
   error('suchdatei: wurzel ist kein Verzeichnis.'); 
end
pfade = {};
datei = upper(datei);
ld    = length(datei);
n     = 1;
cdir  = dir(wurzel);
for k=1:length(cdir)
   ucn = upper(cdir(k).name);
   if strcmp(datei,ucn) | (teil&findstr(datei,ucn) & ld<length(ucn))
      pfade{n} = {[wurzel,'\',ucn];cdir(k).date;cdir(k).bytes};
      n = n + 1;
   end;
   if cdir(k).isdir & ~strcmp(cdir(k).name(end),'.')
      ccdir = [wurzel,'\',ucn];
      if isdir(ccdir) & ~strcmp(ccdir(end),'.')
         neupf = suchalle(datei,ccdir,teil);
         if ~isempty(neupf)
            for m=1:length(neupf)
               pfade{n} = neupf{m};
               n = n + 1;
            end
         end
      end
   end
end 
