function togglevisibility
% Toggeln der Sichtbarkeit durch Eingabe ber die Tastatur:
% Durch Drcken der Zifferntaste  z (z = 1...9) kann im 
% obenliegenden Fenster das Linienobjekt z verndert werden. 

% Autor: K. von der Heide, e-mail:  v.d.heide@on-line.de

ob  = findobj;                        % alle Objekte
fg = ob(find((ob==round(ob))&ob>0));  % alle Bilder
lo = findobj(gcf,'type','line');      % alle line-Objekte
cc = get(gcf,'CurrentCharacter');     % Eingabezeichen
k  = double(cc) - 48;                 % Objektnummer
if (k>0)&(k<=length(lo))
   al = lo(length(lo) - k + 1);       % Index in der Liste
   vs = get(al,'Visible');            % Sichtbarkeit
   switch vs
      case 'off',  set(al,'Visible','on');
      case 'on',   set(al,'Visible','off');
   end
end
switch cc
   case 'h'                           % Taste "h"
      fs = 12;
      helpwin = figure;
      set(helpwin,'NumberTitle','off','Name','HelpWin',...
         'Color','w','MenuBar','none','Position',[4 427 407 266],...
         'keypressfcn','togglevisibility')
      axis([0,80,1,12]); axis off
      text(0,11,'Das obenliegende Bild kann durch','FontSize',fs)
      text(0,10,'Tastatureingabe verndert werden:','FontSize',fs)
      text(0,9,'Taste   Wirkung','FontSize',fs)
      text(0,8,'  1     Toggeln der Sichtbarkeit des Line-Objektes 1','FontSize',fs)
      text(0,7,'  2     Toggeln der Sichtbarkeit des Line-Objektes 2','FontSize',fs)
      text(0,6,' usw. bis maximal 9','FontSize',fs)
      text(0,5,'  n     nchstes Bild fokussieren','FontSize',fs)
      text(0,4,'  h     dieses Hilfe-Fenster erzeugen','FontSize',fs)
      text(0,3,'  p     fokussiertes Fenster drucken','FontSize',fs)
      text(0,2,'"Entf"  das obenliegende Fenster lschen','FontSize',fs)
      text(0,1,'"ESC"   alle grafischen Fenster lschen','FontSize',fs)
   case 'n'
      fg = rotatevector(fg',1);
      figure(fg(1))
   case 'p',  printdlg(gcf)
end
if double(cc)==27  msvdelfig;   end
if double(cc)==127 delete(gcf); end
