function xzoomvis
% Zoom in x durch Eingabe ber die Tastatur.
% Folgende Tasten haben eine Wirkung:
%  + :  Vergrssern (um die Mitte des Bildes)
%  - :  Verkleinern
%  r :  Scroll rechts
%  l :  Scroll links
%  1 :  Toggeln der Sichtbarkeit des Line-Objektes 1
%  2 :  Toggeln der Sichtbarkeit des Line-Objektes 2
% usw. bis 9

% Autor: K. von der Heide, e-mail:  v.d.heide@on-line.de

xl = get(gca,'XLim');
br = xl(2) - xl(1);
sr = br/50;
cc = get(gcf,'CurrentCharacter');
switch cc
   case '+', set(gca,'XLim',[xl(1)+br/4,xl(2)-br/4])
   case '-', set(gca,'XLim',[xl(1)-br/2,xl(2)+br/2])
   case 'l', set(gca,'XLim',[xl(1)+sr,xl(2)+sr])
   case 'p', printdlg(gcf)
   case 'r', set(gca,'XLim',[xl(1)-sr,xl(2)-sr])
   case {'h','H'} 
      fs = 12;
      helpwin = figure;
      set(helpwin,'NumberTitle','off','Name','HelpWin',...
          'Color','w','MenuBar','none','Position',[4 312 422 248])
      axis([0,80,1,11]); axis off
      text(0,10,'Das obenliegende Bild kann durch','FontSize',fs)
      text(0,9,'Tastatureingabe verndert werden:','FontSize',fs)
      text(0,8,'Taste   Wirkung','FontSize',fs)
      text(0,7,'  +     Vergrssern (um die Mitte des Bildes)','FontSize',fs)
      text(0,6,'  -     Verkleinern','FontSize',fs)
      text(0,5,'  p     Fenster drucken',fs)
      text(0,5,'  r     Scroll rechts','FontSize',fs)
      text(0,4,'  l     Scroll links','FontSize',fs)
      text(0,3,'  1     Toggeln der Sichtbarkeit des Line-Objektes 1','FontSize',fs)
      text(0,2,'  2     Toggeln der Sichtbarkeit des Line-Objektes 2','FontSize',fs)
      text(0,1,' usw. bis maximal 9','FontSize',fs)
   case {'1','2','3','4','5','6','7','8','9'}
      lo = findobj(gcf,'type','line'); % alle line-Objekte
      k  = double(cc) - 48;            % Objektnummer
      al = lo(length(lo) - k + 1);     % Index in der Liste
      vs = get(al,'Visible');          % Sichtbarkeit
      switch vs
         case 'off',  set(al,'Visible','on');
         case 'on',   set(al,'Visible','off');
      end
end   
if double(cc)==27  msvdelfig;   end
if double(cc)==127 delete(gcf); end
