function zoom3d
% zoom3d, Benutzung als KeyPressFcn:
% Zoom in 3D durch Eingabe ber die Tastatur.
% Folgende Tasten haben eine Wirkung:
%  1 :  Nachfolgende Tastatureingabe wirkt auf Richtung 1
%  2 :  Nachfolgende Tastatureingabe wirkt auf Richtung 2
%  3 :  Nachfolgende Tastatureingabe wirkt auf Richtung 3
%  g :  Vergrssern (um die Mitte des Bildes)
%  k :  Verkleinern
%  + :  Scroll in positive Richtung
%  - :  Scroll in negative Richtung
%  i :  wie g
%  o :  wie k
%  p :  Drucken des Bildes
%  x :  Lschen des Bildes
% ESC:  Lschen aller Bilder ausser MSCRIPTVIEW-Fenstern
%
% Diese Funktion verndert die UserData der Achsen des Bildes.

% Autor: K. von der Heide, e-mail:  v.d.heide@on-line.de

c  = get(gcf,'CurrentCharacter');
switch c
   case 'h'
      helpwin = fullscreen('HelpWin','w',0,[1.5 1.8; 1.25 1.0]);
      set(helpwin,'KeyPressFcn','delete(gcf)','ButtonDownFcn','delete(gcf)')
      axis([0,80,1,21]); axis off
      text(0,19.5,'Das obenliegende Bild kann mit der Maus gedreht')
      text(0,18.5,'und durch Tastatureingabe verndert werden:')
      text(0,17.5,'Taste   Wirkung')
      text(0,16,'"ESC"   Lschen aller Bilder')
      text(0,15,'  1     Nachfolgende Tastatureingabe wirkt auf Richtung 1')
      text(0,14,'  2     Nachfolgende Tastatureingabe wirkt auf Richtung 2')
      text(0,13,'  3     Nachfolgende Tastatureingabe wirkt auf Richtung 3')
      text(0,12,'  a     Dialogfenster fr Axeneinstellung')
      text(0,11,'  b     als Bitmap ins Clipboard kopieren')
      text(0,10,'  h     dieses Hilfe-Fenster erzeugen')
      text(0,9,'  g     Vergrssern (um die Mitte des Bildes)')
      text(0,8,'  l     Einblenden eines verschiebbaren Lineals')
      text(0,7,'  k     Verkleinern')
      text(0,6,'  p     Drucken')
      text(0,5,'"Entf"  Lschen des Bildes')
      text(0,4,'  +     Scroll in positive Richtung')
      text(0,3,'  -     Scroll in negative Richtung')
      text(0,2,'  i     View [0 0]')
      text(0,1,'  o     wie k')
   case 'b', print -dbitmap
   case 'p', printdlg(gcf)
   case '1', set(gca,'UserData',1)
   case '2', set(gca,'UserData',2)
   case '3', set(gca,'UserData',3)
   case 'r', set(gca,'View',[0 90])
   case 't', set(gca,'View',[90 0])
   case 'i', set(gca,'View',[0 0])
   otherwise
      strmat =['XLim';'YLim';'ZLim'];
      usdata = get(gca,'UserData');
      if isempty(ismember(usdata,[1 2 3]))  usdata = 1; end
      richtg = strmat(usdata,:);
      xl = get(gca,richtg);
      br = xl(2) - xl(1);
      sr = br/50;
      switch c
         case 'a', axlimdlg
         case 'g', set(gca,richtg,[xl(1)+br/4,xl(2)-br/4])
         case 'k', set(gca,richtg,[xl(1)-br/2,xl(2)+br/2])
         case 'l'
            incell  = inputdlg('Abstand der Marken in Einheiten der Achse','Lineal');
            grid    = eval(['[',incell{1},']',]);
            lineal(usdata,'r',grid,0.02)
         case '-', set(gca,richtg,[xl(1)+sr,xl(2)+sr])
         case '+', set(gca,richtg,[xl(1)-sr,xl(2)-sr])
      end
end   
if double(c)==27  msvdelfig;   end
if double(c)==127 delete(gcf); end
